/// プラグインの処理結果クラスの定義。
/**
	@file	result.d
	@author	senzogawa
**/
module szpd.result;

/// 処理結果クラス。
/**
	@class Result result.d
**/
class Result
{
	/// 結果の値を表現する列挙体
	enum
	{
		SUCCESS   =  1,	///< 処理成功
		FAILURE   =  0,	///< 処理失敗
		ERROR     = -1,	///< 処理不可
		EXCEPTION = -2	///< 例外発生
	}
	
	/// コンストラクタ。
	this()
	{
		this(0, "");
	}
	
	/// コンストラクタ。
	this(int aNum, char[] aStr)
	{
		set(aNum, aStr);
	}

	/// コピーコンストラクタ。
	this(Result aResult)
	{
		mNum = aResult.num;
		mStr = aResult.str;
	}

	/// 結果の数値と文字列を設定する。
	void set(int aNum, char[] aStr)
	{
		mNum = aNum;
		mStr = aStr;
	}

	// プロパティ
	
	void str(char[] aStr)
	{
		mStr = aStr;
	}
	
	char[] str()
	{
		return mStr;
	}
	
	void num(int aNum)
	{
		mNum = aNum;
	}
	
	int num()
	{
		return mNum;
	}

private:
	// 結果文字列
	char[] mStr;

	// 結果数値
	int mNum;
}
